package xyz.lychee.lagfixer.libs.adventure.text;

import java.util.Objects;
import java.util.stream.Stream;
import xyz.lychee.lagfixer.libs.annotations.Contract;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.examination.ExaminableProperty;

public interface KeybindComponent extends BuildableComponent<KeybindComponent, Builder>, ScopedComponent<KeybindComponent> {
   @NotNull String keybind();

   @Contract(
      pure = true
   )
   @NotNull KeybindComponent keybind(final @NotNull String keybind);

   @Contract(
      pure = true
   )
   default @NotNull KeybindComponent keybind(@NotNull final @NotNull KeybindLike keybind) {
      return this.keybind(((KeybindLike)Objects.requireNonNull(keybind, "keybind")).asKeybind());
   }

   default @NotNull Stream<? extends ExaminableProperty> examinableProperties() {
      return Stream.concat(Stream.of(ExaminableProperty.of("keybind", this.keybind())), BuildableComponent.super.examinableProperties());
   }

   public interface Builder extends ComponentBuilder<KeybindComponent, Builder> {
      @Contract("_ -> this")
      @NotNull
      @NotNull Builder keybind(final @NotNull String keybind);

      @Contract(
         pure = true
      )
      @NotNull
      default @NotNull Builder keybind(@NotNull final @NotNull KeybindLike keybind) {
         return this.keybind(((KeybindLike)Objects.requireNonNull(keybind, "keybind")).asKeybind());
      }
   }

   public interface KeybindLike {
      @NotNull String asKeybind();
   }
}
